"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.IMAPFolderStatus = void 0;
const tslib_1 = require("tslib");
const path = tslib_1.__importStar(require("path"));
// tslint:disable-next-line: no-var-requires
const bindings = require(path.join(__dirname, "../../lib/binding/trusted_mailcore2.node"));
// tslint:disable-next-line
const { IMAPFolderStatus: _IMAPFolderStatus } = bindings;
/**
 *
 *
 * @class IMAPFolderStatus
 * @extends {bindings.IMAPFolderStatus}
 */
class IMAPFolderStatus extends bindings.IMAPFolderStatus {
    constructor() {
        super();
        const handle = new _IMAPFolderStatus();
        this.handle = handle;
    }
    /**
     * Get unseenCount
     *
     * @type {number}
     * @memberof IMAPFolderStatus
     */
    get unseenCount() {
        return this.handle.unseenCount;
    }
    /**
     * Set unseenCount
     *
     * @memberof IMAPFolderStatus
     */
    set unseenCount(count) {
        this.handle.unseenCount = count;
    }
    /**
     * Get messageCount
     *
     * @type {number}
     * @memberof IMAPFolderStatus
     */
    get messageCount() {
        return this.handle.messageCount;
    }
    /**
     * Set messageCount
     *
     * @memberof IMAPFolderStatus
     */
    set messageCount(count) {
        this.handle.messageCount = count;
    }
    /**
     * Get recentCount
     *
     * @type {number}
     * @memberof IMAPFolderStatus
     */
    get recentCount() {
        return this.handle.recentCount;
    }
    /**
     * Set recentCount
     *
     * @memberof IMAPFolderStatus
     */
    set recentCount(count) {
        this.handle.recentCount = count;
    }
    /**
     * Get uidNext
     *
     * @type {number}
     * @memberof IMAPFolderStatus
     */
    get uidNext() {
        return this.handle.uidNext;
    }
    /**
     * Set uidNext
     *
     * @memberof IMAPFolderStatus
     */
    set uidNext(uid) {
        this.handle.uidNext = uid;
    }
    /**
     * Get uidValidity
     *
     * @type {number}
     * @memberof IMAPFolderStatus
     */
    get uidValidity() {
        return this.handle.uidValidity;
    }
    /**
     * Set uidValidity
     *
     * @memberof IMAPFolderStatus
     */
    set uidValidity(uid) {
        this.handle.uidValidity = uid;
    }
    /**
     * Get highestModSeqValue
     *
     * @type {number}
     * @memberof IMAPFolderStatus
     */
    get highestModSeqValue() {
        return this.handle.highestModSeqValue;
    }
    /**
     * Set highestModSeqValue
     *
     * @memberof IMAPFolderStatus
     */
    set highestModSeqValue(mod) {
        this.handle.highestModSeqValue = mod;
    }
    description() {
        return this.handle.description();
    }
}
exports.IMAPFolderStatus = IMAPFolderStatus;
//# sourceMappingURL=IMAPFolderStatus.js.map